// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Contains the os disk image information.
    /// </summary>
    public partial class OSDiskImage
    {
        /// <summary>
        /// Initializes a new instance of the OSDiskImage class.
        /// </summary>
        public OSDiskImage() { }

        /// <summary>
        /// Initializes a new instance of the OSDiskImage class.
        /// </summary>
        public OSDiskImage(string operatingSystem)
        {
            OperatingSystem = operatingSystem;
        }

        /// <summary>
        /// Gets or sets the operating system of the osDiskImage. Possible
        /// values for this property include: 'Windows', 'Linux'.
        /// </summary>
        [JsonProperty(PropertyName = "operatingSystem")]
        public string OperatingSystem { get; set; }

        /// <summary>
        /// Validate the object. Throws ArgumentException or ArgumentNullException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (OperatingSystem == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "OperatingSystem");
            }
        }
    }
}
