// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// Text format.
    /// </summary>
    public partial class TextFormat : StorageFormat
    {
        private string _columnDelimiter;
        
        /// <summary>
        /// Optional. The column delimiter.
        /// </summary>
        public string ColumnDelimiter
        {
            get { return this._columnDelimiter; }
            set { this._columnDelimiter = value; }
        }
        
        private string _encodingName;
        
        /// <summary>
        /// Optional. The code page name of the preferred encoding. If miss,
        /// the default value is “utf-8”, unless BOM denotes another Unicode
        /// encoding. Refer to the “Name” column of the table in the following
        /// link to set supported values:
        /// https://msdn.microsoft.com/library/system.text.encoding.aspx.
        /// </summary>
        public string EncodingName
        {
            get { return this._encodingName; }
            set { this._encodingName = value; }
        }
        
        private string _escapeChar;
        
        /// <summary>
        /// Optional. The escape character.
        /// </summary>
        public string EscapeChar
        {
            get { return this._escapeChar; }
            set { this._escapeChar = value; }
        }
        
        private string _nullValue;
        
        /// <summary>
        /// Optional. The null value string.
        /// </summary>
        public string NullValue
        {
            get { return this._nullValue; }
            set { this._nullValue = value; }
        }
        
        private string _quoteChar;
        
        /// <summary>
        /// Optional. Gets or sets the quote character.
        /// </summary>
        public string QuoteChar
        {
            get { return this._quoteChar; }
            set { this._quoteChar = value; }
        }
        
        private string _rowDelimiter;
        
        /// <summary>
        /// Optional. The row delimiter.
        /// </summary>
        public string RowDelimiter
        {
            get { return this._rowDelimiter; }
            set { this._rowDelimiter = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TextFormat class.
        /// </summary>
        public TextFormat()
        {
        }
    }
}
