// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// Metadata for an Operational Insights account that isn't linked to a
    /// workspace.
    /// </summary>
    public partial class Account
    {
        private string _accountName;
        
        /// <summary>
        /// Optional. Gets or sets the name of the account.
        /// </summary>
        public string AccountName
        {
            get { return this._accountName; }
            set { this._accountName = value; }
        }
        
        private System.Guid? _customerId;
        
        /// <summary>
        /// Optional. Gets or sets the unique ID of the account.
        /// </summary>
        public System.Guid? CustomerId
        {
            get { return this._customerId; }
            set { this._customerId = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. Gets or sets the Azure region that the account was
        /// created in.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _workspaceName;
        
        /// <summary>
        /// Optional. Gets or sets the DNS valid workspace name associated with
        /// the account.
        /// </summary>
        public string WorkspaceName
        {
            get { return this._workspaceName; }
            set { this._workspaceName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Account class.
        /// </summary>
        public Account()
        {
        }
    }
}
