// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.StreamAnalytics;
using Microsoft.Azure.Management.StreamAnalytics.Models;

namespace Microsoft.Azure.Management.StreamAnalytics
{
    public static partial class SubscriptionOperationsExtensions
    {
        /// <summary>
        /// Get the stream analytics quotas of a subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.StreamAnalytics.ISubscriptionOperations.
        /// </param>
        /// <param name='location'>
        /// Required. The region that you want to check the quotas.
        /// </param>
        /// <returns>
        /// The response of the get stream analytics quotas operation.
        /// </returns>
        public static SubscriptionQuotasGetResponse GetQuotas(this ISubscriptionOperations operations, string location)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((ISubscriptionOperations)s).GetQuotasAsync(location);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Get the stream analytics quotas of a subscription.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.StreamAnalytics.ISubscriptionOperations.
        /// </param>
        /// <param name='location'>
        /// Required. The region that you want to check the quotas.
        /// </param>
        /// <returns>
        /// The response of the get stream analytics quotas operation.
        /// </returns>
        public static Task<SubscriptionQuotasGetResponse> GetQuotasAsync(this ISubscriptionOperations operations, string location)
        {
            return operations.GetQuotasAsync(location, CancellationToken.None);
        }
    }
}
