// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// The data disk configuration.
    /// </summary>
    public partial class DataDiskConfigurationUpdateParameters
    {
        private string _hostCaching;
        
        /// <summary>
        /// Optional. Optional. Host caching option for a data disk within the
        /// VM Image. 'ReadOnly', 'ReadWrite', or 'None'.If this parameter is
        /// specified you must also specify the Name for the
        /// DataDiskConfiguration you want to change.
        /// </summary>
        public string HostCaching
        {
            get { return this._hostCaching; }
            set { this._hostCaching = value; }
        }
        
        private int? _logicalUnitNumber;
        
        /// <summary>
        /// Optional. Optional. LUN for the data disk. LUNs must not conflict
        /// with other Data Disks in the VM Image. If this parameter is
        /// specified you must also specify the Name for the
        /// DataDiskConfiguration you want to change.
        /// </summary>
        public int? LogicalUnitNumber
        {
            get { return this._logicalUnitNumber; }
            set { this._logicalUnitNumber = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Optional if not changing any data disk configurations.
        /// Name of an existing DataDiskConfiguration. The name cannot be
        /// changed, this is just to identify the disk for changing other
        /// properties.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// DataDiskConfigurationUpdateParameters class.
        /// </summary>
        public DataDiskConfigurationUpdateParameters()
        {
        }
    }
}
