// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.ExpressRoute.Models;

namespace Microsoft.WindowsAzure.Management.ExpressRoute.Models
{
    /// <summary>
    /// Describes a Dedicated Circuit Link.
    /// </summary>
    public partial class AzureDedicatedCircuitLink
    {
        private DedicatedCircuitLinkState _state;
        
        /// <summary>
        /// Optional. State of the dedicated circuit link. Values can be
        /// NotProvisioned, Provisioning, Provisioned, Deprovisioning, or
        /// ProvisioningError.
        /// </summary>
        public DedicatedCircuitLinkState State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _vnetName;
        
        /// <summary>
        /// Optional. The name of the Vnet that is linked.
        /// </summary>
        public string VnetName
        {
            get { return this._vnetName; }
            set { this._vnetName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureDedicatedCircuitLink class.
        /// </summary>
        public AzureDedicatedCircuitLink()
        {
        }
    }
}
