// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.MediaServices.Models
{
    /// <summary>
    /// Parameters supplied to the Create Media Services Account operation.
    /// </summary>
    public partial class MediaServicesAccountCreateParameters
    {
        private string _accountName;
        
        /// <summary>
        /// Required. The name of the Media Services account to create.
        /// </summary>
        public string AccountName
        {
            get { return this._accountName; }
            set { this._accountName = value; }
        }
        
        private Uri _blobStorageEndpointUri;
        
        /// <summary>
        /// Required. The url of the blob storage endpoint associated with the
        /// created Media Services account
        /// </summary>
        public Uri BlobStorageEndpointUri
        {
            get { return this._blobStorageEndpointUri; }
            set { this._blobStorageEndpointUri = value; }
        }
        
        private string _region;
        
        /// <summary>
        /// Required. The region associated with the created Media Services
        /// account
        /// </summary>
        public string Region
        {
            get { return this._region; }
            set { this._region = value; }
        }
        
        private string _storageAccountKey;
        
        /// <summary>
        /// Required. The access key of the storage account associated with the
        /// created Media Services account
        /// </summary>
        public string StorageAccountKey
        {
            get { return this._storageAccountKey; }
            set { this._storageAccountKey = value; }
        }
        
        private string _storageAccountName;
        
        /// <summary>
        /// Required. The name of the storage account associated with the
        /// created Media Services account
        /// </summary>
        public string StorageAccountName
        {
            get { return this._storageAccountName; }
            set { this._storageAccountName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// MediaServicesAccountCreateParameters class.
        /// </summary>
        public MediaServicesAccountCreateParameters()
        {
        }
    }
}
