// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RecoveryServices.Models
{
    /// <summary>
    /// The definition of a cloud service object.
    /// </summary>
    public partial class CloudServiceCreateArgs
    {
        private string _description;
        
        /// <summary>
        /// Required. Description for the cloud service.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private string _email;
        
        /// <summary>
        /// Optional. Optional e-mail address to associate with the service.
        /// </summary>
        public string Email
        {
            get { return this._email; }
            set { this._email = value; }
        }
        
        private string _geoRegion;
        
        /// <summary>
        /// Required. The region for the cloud service. This field cannot be
        /// updated after the cloud service is created.
        /// </summary>
        public string GeoRegion
        {
            get { return this._geoRegion; }
            set { this._geoRegion = value; }
        }
        
        private string _label;
        
        /// <summary>
        /// Required. Label for the cloud service.
        /// </summary>
        public string Label
        {
            get { return this._label; }
            set { this._label = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CloudServiceCreateArgs class.
        /// </summary>
        public CloudServiceCreateArgs()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the CloudServiceCreateArgs class with
        /// required arguments.
        /// </summary>
        public CloudServiceCreateArgs(string label, string description, string geoRegion)
            : this()
        {
            if (label == null)
            {
                throw new ArgumentNullException("label");
            }
            if (description == null)
            {
                throw new ArgumentNullException("description");
            }
            if (geoRegion == null)
            {
                throw new ArgumentNullException("geoRegion");
            }
            this.Label = label;
            this.Description = description;
            this.GeoRegion = geoRegion;
        }
    }
}
